import argparse
from multiprocessing import freeze_support
import os
from itertools import count
import torch.multiprocessing as mp
import torch
import torch.distributed.rpc as rpc
import torch.optim as optim
from torch.distributed.rpc import RRef, rpc_async, remote
from torch.distributions import Categorical
import torch.multiprocessing as mp
from RpcAgent import Agent
AGENT_NAME='server'
OBSERVER_NAME='obs{}'

def init_worker(rank,world_size):
    print(rank,world_size)
    os.environ['MASTER_ADDR']='localhost'
    os.environ['MASTER_PORT']='29000'
    if rank==0:
        rpc.init_rpc(AGENT_NAME,rank=rank,world_size=world_size+1)
        agent=Agent(world_size,OBSERVER_NAME)
        agent.loadGraph('./part/metis_2')
        for i in range(10):
            agent.run_sample(5,3)

    else:
        print(OBSERVER_NAME.format(rank-1))
        rpc.init_rpc(OBSERVER_NAME.format(rank-1),rank=rank,world_size=world_size+1)
    rpc.shutdown()


parser = argparse.ArgumentParser(
    description="RPC Reinforcement Learning Example",
    formatter_class=argparse.ArgumentDefaultsHelpFormatter,
)

parser.add_argument('--world_size', default=2, type=int, metavar='W',
                    help='number of workers')
parser.add_argument('--log_interval', type=int, default=10, metavar='N',
                    help='interval between training status logs')
parser.add_argument('--gamma', type=float, default=0.99, metavar='G',
                    help='how much to value future rewards')
parser.add_argument('--seed', type=int, default=1, metavar='S',
                    help='random seed  for reproducibility')
args = parser.parse_args()
if __name__ == '__main__':
    mp.spawn(
        init_worker,
        args=(args.world_size, ),
        nprocs=args.world_size+1,
        join=True
    )